"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = exports.loggerPlugin = exports.LoggerPlugin = exports.LogLevel = void 0;
var resolvers_1 = require("./resolvers");
var manifest_1 = require("./manifest");
var core_js_1 = require("@web3api/core-js");
var LogLevel;
(function (LogLevel) {
    LogLevel[LogLevel["DEBUG"] = 0] = "DEBUG";
    LogLevel[LogLevel["INFO"] = 1] = "INFO";
    LogLevel[LogLevel["WARN"] = 2] = "WARN";
    LogLevel[LogLevel["ERROR"] = 3] = "ERROR";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
var LoggerPlugin = /** @class */ (function (_super) {
    __extends(LoggerPlugin, _super);
    function LoggerPlugin(logFunc) {
        var _this = _super.call(this) || this;
        _this._logFunc = logFunc;
        return _this;
    }
    LoggerPlugin.manifest = function () {
        return manifest_1.manifest;
    };
    LoggerPlugin.prototype.getModules = function () {
        return {
            query: resolvers_1.query(this),
        };
    };
    LoggerPlugin.prototype.log = function (level, message) {
        if (this._logFunc) {
            return this._logFunc(level, message);
        }
        switch (level) {
            case LogLevel.DEBUG:
                console.debug(message);
                break;
            case LogLevel.WARN:
                console.warn(message);
                break;
            case LogLevel.ERROR:
                console.error(message);
                break;
            case LogLevel.INFO:
                console.log(message);
                break;
            default:
                console.log(message);
        }
        return true;
    };
    return LoggerPlugin;
}(core_js_1.Plugin));
exports.LoggerPlugin = LoggerPlugin;
exports.loggerPlugin = function () {
    return {
        factory: function () { return new LoggerPlugin(); },
        manifest: manifest_1.manifest,
    };
};
exports.plugin = exports.loggerPlugin;
//# sourceMappingURL=index.js.map